// PerfomanceStatistics.h

#pragma once

#ifndef _PERFOMANCE_STATISTICS_H_
#define _PERFOMANCE_STATISTICS_H_

#include "PerfomanceCounter.h"

//------------------------------------------------------------------------------
// PerfomanceStatistics
//------------------------------------------------------------------------------

class PerfomanceStatistics
{
public:
	PerfomanceStatistics()
		: total_file_bytes_(0)
		, total_assembly_bytes_(0)
#if COLLECT_FORMATTER_PERFOMANCE
#endif // COLLECT_FORMATTER_PERFOMANCE
		//, pass1 ( TRUE )
		//, pass2 ( TRUE )
		//, pass3 ( TRUE )
		//, pass4 ( TRUE )
		//, metadata_pass ( TRUE )
	{}

	size_t total_file_bytes_;
	size_t total_assembly_bytes_;
	PerfomanceData pass1;
	PerfomanceData pass2;
	PerfomanceData pass3;
	PerfomanceData pass4;
	PerfomanceData metadata_pass;
#if COLLECT_FORMATTER_PERFOMANCE
#endif // COLLECT_FORMATTER_PERFOMANCE

	PerfomanceStatistics & operator += ( const PerfomanceStatistics & rhs )
	{
		total_file_bytes_ += rhs.total_file_bytes_;
		total_assembly_bytes_ += rhs.total_assembly_bytes_;
		pass1 += rhs.pass1;
		pass2 += rhs.pass2;
		pass3 += rhs.pass3;
		pass4 += rhs.pass4;
		metadata_pass += rhs.metadata_pass;
#if COLLECT_FORMATTER_PERFOMANCE
#endif // COLLECT_FORMATTER_PERFOMANCE
		return *this;
	}
};

//------------------------------------------------------------------------------

#endif // _PERFOMANCE_STATISTICS_H_
