// RefactoringManager.cpp

#include "stdafx.h"
#include "RefactoringManager.h"

#include "ICsProject.h"
#include "ICsFile.h"
#include "ICsParserInterface.h"
#include "RefactoringRename.h"
#include "FileManager.h"
#include "CharDeque.h"
#include "CommandLineOptions.h"

#include <deque>

//------------------------------------------------------------------------------
// RefactoringManager
//------------------------------------------------------------------------------

RefactoringManager::RefactoringManager()
: project()
{
}

//------------------------------------------------------------------------------

void RefactoringManager::test()
{
	if ( !project )
		return;

	//closeProject();
	//loadProject();
	project->parse();

	int n_files;
	ICsFile ** files;
	project->getFiles ( n_files, files );
	std::deque<ICsFile*> file_deque;
	file_deque.assign ( & files[0], & files[n_files] );
	CsEntityNamespace * global_namespace = project->getGlobalNamespace();

	RefactoringRename rr;
	rr.setProjectData ( global_namespace, file_deque );

//#if 1

	rr.rename ( "RenameLocalEntity.cs", 9, "a", 0, "c" ); // local variable
	rr.rename ( "RenameLocalEntity.cs", 10, "b", 0, "d" ); // local constant
	rr.rename ( "RenameLocalEntity.cs", 17, "i", 0, "j" ); // foreach variable
	rr.rename ( "RenameLocalEntity.cs", 23, "e", 0, "f" ); // catch variable
	rr.rename ( "RenameLocalEntity.cs", 31, "p", 0, "r" ); // formal parameter

	rr.rename ( "RenameClassMember1.cs", 7, "a", 0, "c" ); // variable
	rr.rename ( "RenameClassMember1.cs", 8, "b", 0, "d" ); // constant

	rr.rename ( "RenameMethod2.cs", 9, "f", 0, "g" ); // method
	//rr.rename ( "RenameMethod2.cs", 14, "f", 0, "g" ); // method
	//rr.rename ( "RenameMethod2.cs", 20, "f", 0, "g" ); // method
	//rr.rename ( "RenameMethod2.cs", 26, "f", 0, "h" ); // method
	//rr.rename ( "RenameMethod2.cs", 32, "f", 0, "g" ); // method

	rr.rename ( "RenameProperty2.cs", 9, "p", 0, "r" ); // property
	//rr.rename ( "RenameProperty2.cs", 14, "p", 0, "r" ); // method
	//rr.rename ( "RenameProperty2.cs", 23, "p", 0, "r" ); // method
	//rr.rename ( "RenameProperty2.cs", 32, "p", 0, "r" ); // method
	//rr.rename ( "RenameProperty2.cs", 41, "p", 0, "r" ); // method

	rr.rename ( "RenameType1.cs", 7, "B", 0, "B2" ); // type
	//rr.rename ( "RenameType1.cs", 9, "N", 0, "N2" ); // type
	//rr.rename ( "RenameType1.cs", 15, "B", 0, "B2" ); // type
	//rr.rename ( "RenameType1.cs", 23, "B", 0, "B2" ); // type
	//rr.rename ( "RenameType1.cs", 24, "B", 0, "B2" ); // type
	//rr.rename ( "RenameType1.cs", 24, "N", 0, "N2" ); // type
	//rr.rename ( "RenameType1.cs", 31, "B", 0, "B2" ); // type
	//rr.rename ( "RenameType1.cs", 37, "B", 0, "B2" ); // type

	rr.rename ( "RenameType1.cs", 37, "U", 0, "U2" ); // using directive alias
	//rr.rename ( "RenameType1.cs", 42, "U", 0, "U2" ); // using directive alias

	rr.rename ( "RenameUsingDirective1.cs", 7, "C", 0, "C2" ); // rename type
	//rr.rename ( "RenameUsingDirective1.cs", 12, "C", 0, "C2" ); // rename type
	//rr.rename ( "RenameUsingDirective1.cs", 12, "N1AC", 0, "N1AC2" ); // using directive alias
	//rr.rename ( "RenameUsingDirective1.cs", 16, "N1AC", 0, "N1AC2" ); // using directive alias
	//rr.rename ( "RenameUsingDirective1.cs", 16, "N2AC", 0, "N2AC2" ); // using directive alias
	//rr.rename ( "RenameUsingDirective1.cs", 21, "N2AC", 0, "N2AC2" ); // using directive alias
	//rr.rename ( "RenameUsingDirective1.cs", 25, "C2", 0, "C3" ); // using directive alias
	//rr.rename ( "RenameUsingDirective1.cs", 36, "C2", 0, "C3" ); // using directive alias

	rr.rename ( "RenameNamespace1.cs", 7, "N1", 0, "N3" ); // namespace
	//rr.rename ( "RenameNamespace1.cs", 9, "N2", 0, "N4" ); // namespace
	//rr.rename ( "RenameNamespace1.cs", 15, "N1", 0, "N3" ); // namespace
	//rr.rename ( "RenameNamespace1.cs", 15, "N2", 0, "N4" ); // namespace
	//rr.rename ( "RenameNamespace1.cs", 22, "N1", 0, "N3" ); // namespace
	//rr.rename ( "RenameNamespace1.cs", 22, "N2", 0, "N4" ); // namespace
	//rr.rename ( "RenameNamespace1.cs", 22, "N1", 1, "N3" ); // namespace
	//rr.rename ( "RenameNamespace1.cs", 22, "N2", 1, "N4" ); // namespace

	rr.rename ( "RenameLabel1.cs", 12, "label1", 0, "label12" ); // label
	//rr.rename ( "RenameLabel1.cs", 13, "label2", 0, "label22" ); // label
	//rr.rename ( "RenameLabel1.cs", 14, "label3", 0, "label32" ); // label
	//rr.rename ( "RenameLabel1.cs", 15, "label1", 0, "label12" ); // label
	//rr.rename ( "RenameLabel1.cs", 16, "label2", 0, "label22" ); // label
	//rr.rename ( "RenameLabel1.cs", 20, "label1", 0, "label12" ); // label

//#endif

	project->reparseEntities();

	saveProject();

	//closeProject();
}

//------------------------------------------------------------------------------

void RefactoringManager::saveProject()
{
	int n_files;
	ICsFile ** files;
	project->getFiles ( n_files, files );
	for ( int i = 0; i != n_files; ++i )
	{
		saveFile ( files[i] );
	}
	ICsParserInterface::free ( files );
}

//------------------------------------------------------------------------------

void RefactoringManager::saveFile ( ICsFile * csfile )
{
	std::string output_file;
	bool b = EvalPath (
		csfile->getPath(),
		getCommandLineOptions().input_base_path.c_str(),
		getCommandLineOptions().output_base_path.c_str(),
		output_file );
	if ( !b )
	{
		ASSERT(0);
		return;
	}
	PFile file ( new File ( output_file.c_str() ) );
	file->open ( File::ac_create );
	CharDeque generated_text;
	MediumFastDeque<CsToken>::iterator it = csfile->getTokens().begin();
	MediumFastDeque<CsToken>::iterator it_end = csfile->getTokens().end();
	for ( ; it != it_end; ++it )
	{
		const char * text = (const char*)it->getText();
		if ( text )
		{
			int len = strlen ( text );
			generated_text.push_back ( text, text + len );
		}
	}
	{
		CharDeque::part_iterator it = generated_text.part_begin();
		CharDeque::part_iterator it_end = generated_text.part_end();
		for ( ; it != it_end; ++it )
		{
			CharDeque::part part = * it;
			file->write ( (byte*)part.begin(), part.end() - part.begin() );
		}
	}
	unsigned file_len = 0;
	file->getLength ( file_len );
	file->close();
}

//------------------------------------------------------------------------------
